package com.boman.auth.service;

import com.boman.common.redis.service.RedisService;
import com.boman.domain.dto.AjaxResult;
import com.boman.domain.form.LoginBody;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import com.boman.domain.constant.Constants;
import com.boman.domain.constant.UserConstants;
import com.boman.domain.dto.R;
import com.boman.common.core.enums.UserStatus;
import com.boman.common.core.exception.BaseException;
import com.boman.common.core.utils.SecurityUtils;
import com.boman.common.core.utils.StringUtils;
import com.boman.system.api.RemoteLogService;
import com.boman.system.api.RemoteUserService;
import com.boman.domain.SysUser;
import com.boman.system.api.model.LoginUser;

import static com.boman.domain.constant.Constants.SUCCESS;

/**
 * 登录校验方法
 *
 * @author ruoyi
 */
@Component
public class SysLoginService {
    @Autowired
    private RemoteLogService remoteLogService;

    @Autowired
    private RemoteUserService remoteUserService;

    @Autowired
    private RedisService redisService;

    @Value("${upkeep}")
    private Boolean upKeep;

    /**
     * 登录
     */
    public LoginUser login(String username, String password) {
        if (upKeep && !"admin".equals(username)){
            throw new BaseException("当前正在维护");
        }
        // 用户名或密码为空 错误
        if (StringUtils.isAnyBlank(username, password)) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "用户/密码必须填写");
            throw new BaseException("用户/密码必须填写");
        }

        // 密码如果不在指定范围内 错误
        if (password.length() < UserConstants.PASSWORD_MIN_LENGTH || password.length() > UserConstants.PASSWORD_MAX_LENGTH) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "用户密码不在指定范围");
            throw new BaseException("用户密码不在指定范围");
        }

        // 用户名不在指定范围内 错误
        if (username.length() < UserConstants.USERNAME_MIN_LENGTH || username.length() > UserConstants.USERNAME_MAX_LENGTH) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "用户名不在指定范围");
            throw new BaseException("用户名不在指定范围");
        }
        // 查询用户信息
        R<LoginUser> userResult = remoteUserService.getUserInfo(username);

        if (R.FAIL == userResult.getCode()) {
            throw new BaseException(userResult.getMsg());
        }

        if (StringUtils.isNull(userResult.getData())) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "登录用户不存在");
            throw new BaseException("登录用户：" + username + " 不存在");
        }

        LoginUser userInfo = userResult.getData();
        SysUser user = userResult.getData().getSysUser();
        if (UserStatus.DELETED.getCode().equals(user.getDelFlag())) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "对不起，您的账号已被删除");
            throw new BaseException("对不起，您的账号：" + username + " 已被删除");
        }

        if (UserStatus.DISABLE.getCode().equals(user.getStatus())) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "用户已停用，请联系管理员");
            throw new BaseException("对不起，您的账号：" + username + " 已停用");
        }

        if (!SecurityUtils.matchesPassword(password, user.getPassword())) {
            remoteLogService.saveLogininfor(username, Constants.LOGIN_FAIL, "用户密码错误");
            throw new BaseException("用户不存在/密码错误");
        }
        remoteLogService.saveLogininfor(username, Constants.LOGIN_SUCCESS, "登录成功");
        return userInfo;
    }


    /**
     * APP扫码登录
     *
     * @param form
     * @return
     */
    public R<?> phoneScanLogin(LoginBody form) {
        if(redisService.getCacheObject(form.getUuid()) == null){
            throw new BaseException("登录超时,请重新登录");
        }
        String cacheObject = redisService.getCacheObject(form.getUuid()).toString();
        if (StringUtils.isBlank(cacheObject)) {
            throw new BaseException("登录超时,请重新登录");
        }
        String phone = form.getPhone();
        if (StringUtils.isBlank(phone)) {
            throw new BaseException("缺少参数,手机号码");
        }
        SysUser user = remoteUserService.getByPhone(phone);
        String userName = user.getUserName();
        if (UserStatus.DELETED.getCode().equals(user.getDelFlag())) {
            remoteLogService.saveLogininfor(userName, Constants.LOGIN_FAIL, "对不起，您的账号已被删除");
            throw new BaseException("对不起，您的账号：" + userName + " 已被删除");
        }

        if (UserStatus.DISABLE.getCode().equals(user.getStatus())) {
            remoteLogService.saveLogininfor(userName, Constants.LOGIN_FAIL, "用户已停用，请联系管理员");
            throw new BaseException("对不起，您的账号：" + userName + " 已停用");
        }
        if (upKeep && !"admin".equals(userName)){
            throw new BaseException("当前正在维护");
        }
        remoteLogService.saveLogininfor(userName, Constants.LOGIN_SUCCESS, "登录成功");
        redisService.setCacheObject(form.getUuid(),form.getPhone());
        return R.ok();
    }

    public AjaxResult updateUnionId(SysUser sysUser) {
        return remoteUserService.updateUnionId(sysUser);
    }

    public void logout(String loginName) {
        remoteLogService.saveLogininfor(loginName, Constants.LOGOUT, "退出成功");
    }
}